<ftl-include>
  <div>
    { responseText }
    <div ref='dados'></div>
    <div ref='prog'></div>
    <!-- <ftl-error-message></ftl-error-message> -->
  </div>

  <script>
    var self = this;
    self.debug = false;

    function scriptExecute(extrajavascript) {
      if (extrajavascript != undefined) {
        // Associa da self.refs.prog ao retorno do $('<script>') pois o div prog é perdido quando da atualização
        eval(extrajavascript);
        // return;
        // // Não estava funcionando quando o post dava erro, porque self.ref.prog ficava com duas entradas de script e
        // // Não executava corretamente.
        // var a = $('<script>')
        //   .attr('type', 'text/javascript')
        //   .text(extrajavascript)
        //   .replaceAll(self.refs.prog);
        //   // .replaceAll(self.refs.prog)
        // self.refs.prog = a;
      }
    }

    const fetch = () => {
      $.ajax({
        url: opts.include.url,
        xhrFields: {
          withCredentials: true
        },
        beforeSend: function (xhr, settings) {
          xhr.setRequestHeader("X-CSRFToken", getCookie('csrftoken')); //csrftoken);
          xhr.setRequestHeader("HTTP_X_CSRFTOKEN", getCookie('csrftoken')); //csrftoken);
          self.trigger('loading');
        },
        success: function (data) {
          self.trigger('updateContent', data);
          self.trigger('loaded', data);
          return false;
        },
        error: function (xhr, status, error) {
          if (self.debug) console.log("Something went wrong: >" + xhr + "< >" + status + '< >' + error + '<');
          if (xhr.status === 403) {
            // Forbiden - Não tem permissão
            alert('Desculpe, mas você não tem permissão!');
            window.history.back()
            // } else if ((xhr.status === 500) && (xhr.responseURL !== undefined)) {
            //   window.location = xhr.responseURL;
          } else {
            alert('Request failed.  Returned status of ' + xhr.status);
            document.open();
            document.write(xhr.responseText);
            document.close();
          }
          return false;
        }
      });
    };

    self.on('mount', () => {
      if (self.debug) console.log('ftl-include: mount:', opts.include.url);
      fetch();
    });

    self.on('loading', () => {
      if (self.debug) console.log('ftl-include: loading');

      document.getElementById('ftl-page-load').value = 'loading';

      if (opts.include.showLoading) // Se habilitado mostra janela com mensagem de carregando
        document.getElementById('commonLoad').style.display = "block";
    });

    self.on('loaded', (data) => {
      if (self.debug) console.log('ftl-include: loaded');

      document.getElementById('ftl-page-load').value = 'loaded';

      if (opts.include.showLoading)
        document.getElementById('commonLoad').style.display = "none";
    });

    self.on('updateContent', (obj) => {
      // Mostra uma msg de erro na área de definida
      if (obj.msg !== undefined && obj.msg !== null) {
        if (self.debug) console.log(obj.msg);
        riot.mount('ftl-error-message', {messages: obj.msg});
      }
      // Mostra um alert
      if (obj.alert !== undefined && obj.alert !== null) {
        if (self.debug) console.log(obj.alert);
        alert(obj.alert);
      }
      // Redirect usado em finan.view.assinaturaEditDelete para redirecionar ao MP após POST da compra
      if (obj.redirect !== undefined && obj.redirect !== null) {
        scriptExecute(obj.extrajavascript);
        window.location.href = obj.redirect;
        return
      }

      // Se não houve erro ou houve erro, mas não tem goto, então atualiza com os novos dados
      if (opts.include.safe) self.refs.dados.innerHTML = obj.html;
      else self.responseText = obj.html;

      if (obj.form_errors !== undefined || obj.formset_errors !== undefined) {
        $('input[name="save"]').show(); // Mostra campos de save se houve algum erro na validação
      }

      if (self.debug) console.log("OK: ---\>" + obj + "\<---");

      scriptExecute(obj.extrajavascript);

      // Procura por todos os <form> para inserir evento no submit,
      // porém exclui <form> de janelas modais. Ex.: edição de conta no plano contábil
      $(self.refs.dados).find('form:not([ref="modalForm"])').each(function () {
        $(this).attr('action', opts.include.url + (opts.include.url.endsWith('/') ? '' : '/'));

        $('<input>').attr({type: 'hidden', name: 'csrfmiddlewaretoken', value: getCookie('csrftoken')}).appendTo(this);

        $(this).submit(function (e) {
          // e.preventDefault()

          // var submitClickedName = $(this).data("submitClickedName")
          var submitClickedName = $(document.activeElement)[0].name;
          var submitClickedValue = $(document.activeElement)[0].value;

          if ($(document.activeElement)[0].type === 'checkbox') {
            submitClickedValue = $(document.activeElement)[0].checked;
          }
          document.activeElement.disabled = true;

          $(":disabled").removeProp('disabled');

          $f = $(this);
          var type = $f.attr('method');
          var dados = $f.serialize() + '&' + submitClickedName + '=' + submitClickedValue;
          var url = $f.attr('action');
          $.ajax({
            type: type,
            url: url,
            data: dados,
            xhrFields: {
              withCredentials: true
            },
            beforeSend: function (xhr, settings) {
              xhr.setRequestHeader("X-CSRFToken", getCookie('csrftoken')); //csrftoken);
              xhr.setRequestHeader("HTTP_X_CSRFTOKEN", getCookie('csrftoken')); //csrftoken);
              self.trigger('loading');
            },
            success: function (data) {
              if ((data.form_errors !== undefined && data.form_errors !== null) ||
                (data.formset_errors !== undefined && data.formset_errors !== null)) {
                self.trigger('updateContent', data); // data = req.response
              } else if (data.goto !== undefined) {
                scriptExecute(data.extrajavascript);
                route('/' + data.goto);
              }
              if (self.debug) console.log("OK: ---\>" + data + "\<---");
              self.trigger('updateContent', data); // data = req.response
              self.trigger('loaded', data);
              return false;
            },
            error: function (xhr, status, error) {
              if (self.debug) console.log("Something went wrong: >" + xhr + "< >" + status + '< >' + error + '<');
              document.open();
              document.write(xhr.responseText);
              document.close();
              return false;
            }
          });
          return false;
        });
      });

      self.update();
    });
  </script>
</ftl-include>

